#ifndef __CDFTASKPARAMS_H
#define __CDFTASKPARAMS_H

#include "str.h"

/* parametry algorytmu kompresji, itp. */

/* numer wersji programu i naglowka pliku skompresowanego, BYTE */
#define SFALICVERSION 03

/* nazwa programu z numerem wersji, ASCIIZ */
#define PROGNAME "SFALIC research ver. " STR(SFALICVERSION) 


/* maksymalna dozwolona dlugosc lub szerokosc obrazka */
#define IMG_MAX_DIM 30000


/* parametry procesu kompresji/dekompresji */
/* pobierane z commandline, uzupelniane danymi z pliku we */
/* naglowek do dolaczenia do modulu glownego */
/* do nie dolaczania do modulow z algorytmami */

extern
int	echo,		/* czy echo zinterpretowanej cmdline */
	f_compress,	/* czy kompresja - else dekompresja*/
	noheader,	/* czy pominac zapisywanie naglowka pliku wyjsciowego */
	decoronly,	/* czy pominac kompresje stat - tylko dekorelacja */
				/* flaga nie zapisywana do pliku wy, trzeba pamietac przy "dekompresji" */
	generic8bpp;	/* 8bpp kodowane jako przyp. szczegolny 16bpp */

extern
char * infilename,  /* nazwa pliku we */
	 * outfilename; /* wy */

/* definicje ponizszych externow sa w taskparams.c */
extern
int width,	/* pikseli na wiersz obrazu */
				/* w naglowku skompresowanego zapisywany jako u16 */
	height,	/* liczba wierszy obrazu */
				/* w naglowku skompresowanego zapisywany jako u16 */
	bpp;	/* bitow na piksel */
				/* w naglowku skompresowanego zapisywany jako u8 */

/* wartosci domyslne dla ponizszych externow sa w cdfpred.h i cdfstat.h */
/* definicje tych externow i inicjalizacje wart. domyslnymi sa w taskparams.c */
extern
int pred,		/* numer predyktora */
					/* UWAGA: w naglowku skompresowanego zapisywany jako i8 (ze znakiem) */
	evol,		/* typ ewolucji liczby kubelkow */
					/* w naglowku skompresowanego zapisywany jako u8 */
	trigger,	/* bucket trigger */
					/* UWAGA: w naglowku skompresowanego trigger/10 zapisywany jako u8 */
	maxclen,	/* ograniczenie dlugosci slowa kodowego */
				/* wartosci ujemne to uzaleznienie od bpp - na razie niezaimplementowane*/
					/* w naglowku skompresowanego zapisywany jako u8 */
	wmistart,	/* wait mask index - poczatkowy */
					/* w naglowku skompresowanego zapisywany jako u8 */
	wmimax, 	/* wait mask index - koncowy */
					/* w naglowku skompresowanego zapisywany jako u8 */
	wminext;	/* co ile symboli zwiekszac wait mask index */
					/* UWAGA: w naglowku skompresowanego log_2(wminext) zapisywany jako u8 */ 

/* wypisz na stdout wartosci ww zmiennych */
void printparams();

/* sprawdz wartosci ww. zmiennych - czy w zakresach i wzajemnie niesprzeczne*/
/* w razie bledu koncz program exitit */
void testparams();

#endif
